import _defineProperty from '@babel/runtime/helpers/esm/defineProperty';
import _classCallCheck from '@babel/runtime/helpers/esm/classCallCheck';
import _createClass from '@babel/runtime/helpers/esm/createClass';
import _assertThisInitialized from '@babel/runtime/helpers/esm/assertThisInitialized';
import _inherits from '@babel/runtime/helpers/esm/inherits';
import _createSuper from '@babel/runtime/helpers/esm/createSuper';
import _classPrivateFieldLooseBase from '@babel/runtime/helpers/esm/classPrivateFieldLooseBase';
import _classPrivateFieldLooseKey from '@babel/runtime/helpers/esm/classPrivateFieldLooseKey';
import { isEngine, Plugin } from '@aomao/engine';

var _styleName = /*#__PURE__*/_classPrivateFieldLooseKey("styleName");

var _default = /*#__PURE__*/function (_Plugin) {
  _inherits(_default, _Plugin);

  var _super = _createSuper(_default);

  function _default() {
    var _this;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    Object.defineProperty(_assertThisInitialized(_this), _styleName, {
      writable: true,
      value: 'line-height'
    });
    return _this;
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      var _this2 = this;

      this.editor.schema.add(this.schema());

      if (isEngine(this.editor)) {
        this.editor.on('paste:each', function (node) {
          return _this2.pasteEach(node);
        });
      }
    }
  }, {
    key: "execute",
    value: function execute(lineHeight) {
      var _this3 = this;

      if (!isEngine(this.editor)) return;
      if (lineHeight === 'default') lineHeight = '';
      var _this$editor = this.editor,
          change = _this$editor.change,
          block = _this$editor.block;
      var range = change.range.get();
      var blocks = block.findBlocks(range); // 没找到目标 block

      if (!blocks) {
        return;
      } // 其它情况


      blocks.forEach(function (block) {
        _this3.addLineHeight(block, lineHeight);
      });
    }
  }, {
    key: "queryState",
    value: function queryState() {
      var _this4 = this;

      if (!isEngine(this.editor)) return;
      var _this$editor2 = this.editor,
          change = _this$editor2.change,
          node = _this$editor2.node;
      var range = change.range.get();
      if (!range.startNode.inEditor()) return ['default'];
      var blocks = change.blocks;
      var values = [];
      blocks.forEach(function (block) {
        if (node.isNestedBlock(block)) {
          var _block$get;

          var lineHeightSource = ((_block$get = block.get()) === null || _block$get === void 0 ? void 0 : _block$get.style.lineHeight) || '';
          if (!lineHeightSource) return;

          var lineHeight = _this4.convertToPX(lineHeightSource);

          var filter = _this4.options.filter;

          if (filter) {
            var result = filter(lineHeight);

            if (result === false) {
              return;
            } else if (typeof result === 'string') {
              values.push(result);
            } else values.push(lineHeight);
          }
        }
      });
      return values.length === 0 ? ['default'] : values;
    }
    /**
     * 给 Block 节点增加行高
     * @param block block 节点
     * @param lineHeight 行高
     * @returns
     */

  }, {
    key: "addLineHeight",
    value: function addLineHeight(block, lineHeight) {
      var node = this.editor.node;
      if (!node.isNestedBlock(block)) return;
      block.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName], lineHeight || '');
    }
  }, {
    key: "schema",
    value: function schema() {
      return {
        type: 'block',
        attributes: {
          style: _defineProperty({}, _classPrivateFieldLooseBase(this, _styleName)[_styleName], '@length')
        }
      };
    }
  }, {
    key: "convertToPX",
    value: function convertToPX(value) {
      var match = /([\d\.]+)(pt|px)$/i.exec(value);

      if (match && match[2] === 'pt') {
        return String(Math.round(parseInt(match[1], 10) * 96 / 72)) + 'px';
      }

      return value;
    }
  }, {
    key: "pasteEach",
    value: function pasteEach(node) {
      //pt 转为px
      if (!node.isCard() && this.editor.node.isBlock(node)) {
        var lineHeightSource = node.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName]);
        if (!lineHeightSource) return;
        var lineHeight = this.convertToPX(lineHeightSource);

        if (lineHeightSource.endsWith('pt')) {
          node.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName], lineHeight);
        }

        var filter = this.options.filter;

        if (filter) {
          var result = filter(lineHeight);

          if (result === false) {
            node.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName], '');
          } else if (typeof result === 'string') {
            node.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName], result);
          }
        } else node.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName], '');

        var nodeApi = this.editor.node;
        if (!nodeApi.isBlock(node)) nodeApi.unwrap(node);
      }
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'line-height';
    }
  }]);

  return _default;
}(Plugin);

export default _default;
