'use strict';

var engine = require('@aomao/engine');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

var id = 0;

function _classPrivateFieldLooseKey(name) {
  return "__private_" + id++ + "_" + name;
}

function _classPrivateFieldLooseBase(receiver, privateKey) {
  if (!Object.prototype.hasOwnProperty.call(receiver, privateKey)) {
    throw new TypeError("attempted to use private field on non-instance");
  }

  return receiver;
}

var _styleName = /*#__PURE__*/_classPrivateFieldLooseKey("styleName");

var _default = /*#__PURE__*/function (_Plugin) {
  _inherits(_default, _Plugin);

  var _super = _createSuper(_default);

  function _default() {
    var _this;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    Object.defineProperty(_assertThisInitialized(_this), _styleName, {
      writable: true,
      value: 'line-height'
    });
    return _this;
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      var _this2 = this;

      this.editor.schema.add(this.schema());

      if (engine.isEngine(this.editor)) {
        this.editor.on('paste:each', function (node) {
          return _this2.pasteEach(node);
        });
      }
    }
  }, {
    key: "execute",
    value: function execute(lineHeight) {
      var _this3 = this;

      if (!engine.isEngine(this.editor)) return;
      if (lineHeight === 'default') lineHeight = '';
      var _this$editor = this.editor,
          change = _this$editor.change,
          block = _this$editor.block;
      var range = change.range.get();
      var blocks = block.findBlocks(range); // 没找到目标 block

      if (!blocks) {
        return;
      } // 其它情况


      blocks.forEach(function (block) {
        _this3.addLineHeight(block, lineHeight);
      });
    }
  }, {
    key: "queryState",
    value: function queryState() {
      var _this4 = this;

      if (!engine.isEngine(this.editor)) return;
      var _this$editor2 = this.editor,
          change = _this$editor2.change,
          node = _this$editor2.node;
      var range = change.range.get();
      if (!range.startNode.inEditor()) return ['default'];
      var blocks = change.blocks;
      var values = [];
      blocks.forEach(function (block) {
        if (node.isNestedBlock(block)) {
          var _block$get;

          var lineHeightSource = ((_block$get = block.get()) === null || _block$get === void 0 ? void 0 : _block$get.style.lineHeight) || '';
          if (!lineHeightSource) return;

          var lineHeight = _this4.convertToPX(lineHeightSource);

          var filter = _this4.options.filter;

          if (filter) {
            var result = filter(lineHeight);

            if (result === false) {
              return;
            } else if (typeof result === 'string') {
              values.push(result);
            } else values.push(lineHeight);
          }
        }
      });
      return values.length === 0 ? ['default'] : values;
    }
    /**
     * 给 Block 节点增加行高
     * @param block block 节点
     * @param lineHeight 行高
     * @returns
     */

  }, {
    key: "addLineHeight",
    value: function addLineHeight(block, lineHeight) {
      var node = this.editor.node;
      if (!node.isNestedBlock(block)) return;
      block.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName], lineHeight || '');
    }
  }, {
    key: "schema",
    value: function schema() {
      return {
        type: 'block',
        attributes: {
          style: _defineProperty({}, _classPrivateFieldLooseBase(this, _styleName)[_styleName], '@length')
        }
      };
    }
  }, {
    key: "convertToPX",
    value: function convertToPX(value) {
      var match = /([\d\.]+)(pt|px)$/i.exec(value);

      if (match && match[2] === 'pt') {
        return String(Math.round(parseInt(match[1], 10) * 96 / 72)) + 'px';
      }

      return value;
    }
  }, {
    key: "pasteEach",
    value: function pasteEach(node) {
      //pt 转为px
      if (!node.isCard() && this.editor.node.isBlock(node)) {
        var lineHeightSource = node.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName]);
        if (!lineHeightSource) return;
        var lineHeight = this.convertToPX(lineHeightSource);

        if (lineHeightSource.endsWith('pt')) {
          node.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName], lineHeight);
        }

        var filter = this.options.filter;

        if (filter) {
          var result = filter(lineHeight);

          if (result === false) {
            node.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName], '');
          } else if (typeof result === 'string') {
            node.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName], result);
          }
        } else node.css(_classPrivateFieldLooseBase(this, _styleName)[_styleName], '');

        var nodeApi = this.editor.node;
        if (!nodeApi.isBlock(node)) nodeApi.unwrap(node);
      }
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'line-height';
    }
  }]);

  return _default;
}(engine.Plugin);

module.exports = _default;
